function [H,DH,num_c]=Hessian_end(g,x,y,t,length_I,g_need,I_need,max_g)

global  dim_g nv meth num_smooth

  f_x=obj_grad(x); f_xx=obj_hes(x);
 if meth==1
    I_need=(1:dim_g)';
    num_c=dim_g;
    num_smooth=num_smooth+num_c;
    g_x=con_grad(x,I_need,dim_g); g_xx=con_hes(x,I_need,dim_g); 
    H=[f_x+g_x*y; y.*g];    
    Hx=[f_xx+reshape(g_xx*y,nv,nv); spdiags(y,0,dim_g,dim_g)*g_x'];
    Hy=[g_x; spdiags(g,0,dim_g,dim_g)];
    DH=[Hx Hy];   
    return
elseif meth==2
    num_c=dim_g;
    num_smooth=num_smooth+num_c;
    [g_a,g_x,g_t,g_xx]=aggregate(x,t,g); 
    H  = [f_x+g_x*y; y*g_a];
    
    Hx = [f_xx+y*g_xx; y*g_x'];
    Hy = [g_x;g_a];
    DH = [Hx Hy]; 
    return
elseif meth==3 
    if length_I>0
        num_c=length_I;
        num_smooth=num_smooth+num_c;
        [g_a,g_x,g_t,g_xx]=aggregate(x,t,g_need,I_need,length_I);
        H  = [f_x+y*g_x; y*g_a];
        Hx = [f_xx+y*g_xx; y*g_x'];
        Hy = [g_x;g_a];
        DH = [Hx Hy];
        return
    end
elseif meth==4 
    global theta
    num_c=length_I;
    num_smooth=num_smooth+num_c;
    t_theta=t*theta;             
    g_i_x=con_grad(x,I_need,length_I);     
    g_i_xx=con_hes(x,I_need,length_I); 
    term = exp((g_need-max_g)/t_theta);
    lambda = term/sum(term);
    g_a = t_theta*log(sum(term))+max_g;
    g_x = g_i_x*lambda;
    term=repmat(lambda',nv,1);
    g_xx = reshape(g_i_xx*lambda,nv,nv)+ g_i_x.*term*g_i_x'./t_theta-g_x*g_x'/t_theta;
    H  = [f_x+y*g_x; y*g_a];
    Hx = [f_xx+y*g_xx; y*g_x'];
    Hy = [g_x; g_a];
    DH = [Hx Hy];
    return    
end

return