function [x,y,H,k,err]=Newton_fix_t(first_x,first_y,t,t_small,m_max,epison,x,y)
                                                
% Newton correct to solve H=0 and & d'[z-first_z; t-first_t]=0

global  nv meth dim_g num_smooth
k=0;
err=inf;
% initial point
x1=first_x;   
y1=first_y;
% % % % % % % 
if t>t_small|t<=0
    t=t_small;
end
if meth==1
    n=nv+dim_g;
else
    n=nv+1;
end
g=con_fun(x1);
if meth==1
    I_need=(1:dim_g)';length_I=dim_g;
    [H,f_x,g_x]=H_CHIP_end(x1,y1,g,dim_g,I_need); 
    DH=DH_CHIP_end(x1,y1,g,g_x,nv,dim_g,I_need);
    num_smooth=num_smooth+dim_g;    
elseif meth==2
    I_need=(1:dim_g)';length_I=dim_g;
    [H,f_x,g_x,g_i_x,g_a,t_theta,lambda]=H_ACH_end(x1,y1,t,g,dim_g,I_need);
    [DH]=DH_ACH_end(x1,y1,g_a,g_x,t_theta,g_i_x,lambda,I_need,nv,dim_g);
    num_smooth=num_smooth+dim_g; 
elseif meth==3
    global b g0
    I_need=find(g>-b);   
    length_I=length(I_need);         
    if length_I>0
         g_need=g(I_need);
         max_g=max([g_need;g0]);
        [H,f_x,g_x,g_a,t_theta,g_i_x,lambda,term_exp,term_sum,term_1,alpha,grad_s,hess_s]=...
            H_MACH_end(x1,t,length_I,y1,max_g,g_need,I_need);
%         if g_a>1e-6
%             return 
%         end

        [DH]=DH_MACH_end(x1,nv,length_I,y1,g_x,I_need,g_a,t_theta,g_i_x,lambda,term_exp,term_sum,alpha,grad_s,hess_s);
        
         
        num_smooth=num_smooth+length_I; 
    else
        H=obj_grad(x1); DH=obj_hes(x1);
    end
    
elseif meth==4
    global theta bound_alpha bound_g bound_grad_g bound_hess_g epsilon_grad epsilon_hess;
    t_theta=t*theta;    
    a_g=bound_alpha*((1-t)*2*bound_grad_g+t_theta);
    b_g=(1-t)*bound_alpha*(2*bound_hess_g+6/t_theta*bound_grad_g*(bound_grad_g+bound_g/t))+...
        2*(2*bound_alpha+1-t)*bound_grad_g+t_theta+bound_alpha/t*(t_theta+2*bound_g);       
    term=max(2*a_g/epsilon_grad,2*b_g/epsilon_hess);
    M_g=t_theta*log((dim_g-1)*term);    
    max_g = max(g);
    I_need=find(g>=max_g-M_g);
    length_I=length(I_need);                    
    g_need=g(I_need); 
    [H,f_x,g_x,g_a,t_theta,g_i_x,lambda]=H_TACH_end(x1,y1,t,max_g,length_I,g_need,I_need);    
    DH=DH_TACH_end(x1,y1,length_I,g_x,I_need,g_a,t_theta,g_i_x,lambda,nv);
    num_smooth=num_smooth+length_I; 
elseif meth==5
    global  c g0
    I_need=find(g>-c); 
    length_I=length(I_need); 
    if length_I>0
        g_need=g(I_need);
        [H,f_x,g_x,g_i_x,g_a,t_theta,lambda]=H_SACH_end(x1,t,y1,length_I,g_need,I_need);
%         if g_a>1e-6
%             return 
%         end
        [DH]=DH_SACH_end(x1,nv,length_I,y1,g_a,g_x,t_theta,g_i_x,lambda,I_need);
        num_smooth=num_smooth+length_I; 
    else
        H=obj_grad(x1); DH=obj_hes(x1);
    end
    
   elseif meth==6
         global theta
      [g_need,length_I,t_theta,I_need,h]=cell_find(-g,t,theta);
  
    [H,f_x,g_x,g_i_x,g_a,lambda_x]=H_SCH_end(x1,y1,t,g,length_I,I_need,g_need,t_theta,h);
  %  xnew=x1+1e-12*[1 0 0 0]';
%[Hnew,f_xnew,g_xnew,g_i_xnew,g_anew,lambda_xnew]=H_SCH_end(xnew,y1,t,g,length_I,I_need,g_need,t_theta,h);
 %        hessne=1e12*(Hnew-H);
    if length_I>1
   [DH]=DH_SCH_end(x1,y1,g,g_a,g_x,t,g_i_x,lambda_x,I_need,nv,length_I,t_theta,g_need,h);
    else
    [DH]=DH_SCH_end_1(x1,y1,g,g_a,g_x,t,g_i_x,lambda_x,I_need,nv,length_I,t_theta,g_need);
    end
  %  DH(:,1)-hessne
    num_smooth=num_smooth+length_I;  
end

while 1
%     if min(sum(abs(DH),1))<1e-5|min(sum(abs(DH),2))<1e-5
%         Index=ones(n,1);
%         for i=1:size(DH,1)            
%             if norm(DH(:,i))<1e-5
%                 Index(i)=0;
%                 if H(i)>1e-5
%                     x=[];y=[];
%                     return
%                 end 
%             end
%         end
%         DH0=zeros(n,sum(Index));l=0;
%         for i=1:size(DH,1)            
%             if Index(i)
%                 DH0(:,i-l)=DH(:,i);
%             else
%                 l=l+1;
%             end            
%         end
%         h0=-(DH0'*DH0)\DH0'*H ;
%         con=cond(DH0'*DH0);
%         h=zeros(n,1);
%         l=0;
%         for i=1:n
%             if Index(i)
%                 h(i)=h0(i-l);
%             else
%                 l=l+1;
%             end            
%         end
%     else
        h_h=-DH\H;
%     end        
    k=k+1;  
    x2=x1+h_h(1:nv); 
    if  length_I==0  
        y2=0;
    else
        y2=y1+h_h(nv+1:end);
    end
    nh=norm(h_h);
    g=con_fun(x2);
    if dim_g==1
        g_max=g;
    else
        g_max=max(g);
    end
    if nh>100|g_max>100
        return
    end    
    if meth==1
        [H,f_x,g_x]=H_CHIP_end(x2,y2,g,dim_g,I_need); 
    elseif meth==2        
        [H,f_x,g_x,g_i_x,g_a,t_theta,lambda]=H_ACH_end(x2,y2,t,g,dim_g,I_need);
    elseif meth==3
        I_need=find(g>-b);       
        length_I=length(I_need);       
        if length_I>0
             g_need=g(I_need);
             max_g=max([g_need;g0]);
            [H,f_x,g_x,g_a,t_theta,g_i_x,lambda,term_exp,term_sum,term_1,alpha,grad_s,hess_s]=...
                H_MACH_end(x2,t,length_I,y2,max_g,g_need,I_need);
        else
            H=obj_grad(x2); 
        end
    elseif meth==4    
        max_g = max(g);
        I_need=find(g>=max_g-M_g);
        length_I=length(I_need);                 
        g_need=g(I_need); 
        [H,f_x,g_x,g_a,t_theta,g_i_x,lambda]=H_TACH_end(x2,y2,t,max_g,length_I,g_need,I_need);
    elseif meth==5
         I_need=find(g>-c); 
         length_I=length(I_need); 
         if length_I>0
             g_need=g(I_need);
             [H,f_x,g_x,g_i_x,g_a,t_theta,lambda]=H_SACH_end(x2,t,y2,length_I,g_need,I_need);
         else
             H=obj_grad(x2); 
         end   
    elseif meth==6
         global theta
      [g_need,length_I,t_theta,I_need,h]=cell_find(-g,t,theta);

    [H,f_x,g_x,g_i_x,g_a,lambda_x]=H_SCH_end(x2,y2,t,g,length_I,I_need,g_need,t_theta,h);
    end
    nH=norm(H,inf);
%     if nh<1e-6&nH>.1
%         x=[];y=[];
%         return
%     end 
    if nH<epison&nh<epison        
        if g_max>1e-6
             return               
        end 
        x=x2;y=y2;
        err=nH; 
        return
    else
        x1=x2;y1=y2; 
    end
    if k==m_max
        if nH<epison&g_max<1e-6
            err=nH; 
            x=x2;y=y2;
            return            
        end 
        return
    end
    if meth==1
        DH=DH_CHIP_end(x2,y2,g,g_x,nv,dim_g,I_need);
        num_smooth=num_smooth+dim_g;
    elseif meth==2        
        [DH]=DH_ACH_end(x2,y2,g_a,g_x,t_theta,g_i_x,lambda,I_need,nv,dim_g);
        num_smooth=num_smooth+dim_g; 
    elseif meth==3
        if length_I>0
            DH=DH_MACH_end(x2,nv,length_I,y2,g_x,I_need,g_a,t_theta,g_i_x,lambda,term_exp,term_sum,alpha,grad_s,hess_s);
            num_smooth=num_smooth+length_I;
        else
            DH=obj_hes(x2);
        end         
    elseif meth==4    
        DH=DH_TACH_end(x2,y2,length_I,g_x,I_need,g_a,t_theta,g_i_x,lambda,nv);
        num_smooth=num_smooth+length_I; 
    elseif meth==5
        if length_I>0
            DH=DH_SACH_end(x2,nv,length_I,y2,g_a,g_x,t_theta,g_i_x,lambda,I_need);
            num_smooth=num_smooth+length_I; 
        else
            DH=obj_hes(x2);
        end     
         elseif  meth==6    
             if length_I>1
        DH=DH_SCH_end(x2,y2,g,g_a,g_x,t,g_i_x,lambda_x,I_need,nv,length_I,t_theta,g_need,h);
             else
                 DH=DH_SCH_end_1(x2,y2,g,g_a,g_x,t,g_i_x,lambda_x,I_need,nv,length_I,t_theta,g_need);
             end
        num_smooth=num_smooth+length_I; 
    end
end
